;*****************CONTADOR DEREACCIN*****************
list p=16F887
#include <P16f887.INC>


CBLOCK 0x20
var
ENDC


#define boton_mas 	PORTC,0;declaro tecla_inc al portC0
#define boton_stop PORTC,1;declaro boton_stop al portC1
#define vis_led		PORTB


org 0;inicio del programa
;******************************************************
;********programa principal de seteos de segundos**
;******************************************************
principal
	
		call PIC_SET ;seteo del pic 16f887 
		clrf vis_led; se limpia los leds del port B
		clrf var; se encera la variable contadora
		
	
menu_inicio
		btfss boton_mas; pregunta por boton_mas
		goto test_parar
		goto inc_numero;salta ac si boton_mas es "1"
test_parar
		btfss boton_stop; pregunta por boton_stop
		goto menu_inicio
		goto parar;salta ac si boton_stop es "1"
	
inc_numero
       call Retardo_500ms	;aqui se se llama el redardo de tiempo aninado
	soltar_inc
		btfsc boton_mas; pregunta por boton_mas
		goto menu_inicio
		goto parar;salta ac si boton_mas es "0"
    continuar
		movfw var
		sublw d'255'
		btfss STATUS,Z;pregunta por z del registro STATUS
		goto ok_inc
		goto menu_inicio
		ok_inc
		incf var
		movfw var
		movwf vis_led
		goto inc_numero

	parar
	soltar_parar
		btfss boton_stop
		goto continuar
		
		movfw var
		movwf vis_led
		goto menu_inicio

;;;;;;;;;;;;;;;;;;;;;;;;
		;funciones
;;;;;;;;;;;;;;;;;;;;;;;;;

PIC_SET
		banksel ANSELH
		clrf ANSELH
		clrf ANSEL
	
		banksel TRISC
		bsf boton_mas
		bsf boton_stop
		clrf vis_led ;salidas de leds al puerto B
		
		banksel PORTA
		
return
	
;libreria retardo
CBLOCK
	R_ContA						; Contadores para los retardos.
	R_ContB
	R_ContC
	ENDC

Retardo_10ms					; La llamada "call" aporta 2 ciclos mquina.
	movlw	d'10'				; Aporta 1 ciclo mquina. Este es el valor de "M".
	goto	Retardos_ms			; Aporta 2 ciclos mquina.
Retardo_100ms					; La llamada "call" aporta 2 ciclos mquina.
	movlw	d'100'				; Aporta 1 ciclo mquina. Este es el valor de "M".
	goto	Retardos_ms			; Aporta 2 ciclos mquina.
Retardos_ms
	movwf	R_ContB				; Aporta 1 ciclo mquina.
R1ms_BucleExterno
	movlw	d'249'				; Aporta Mx1 ciclos mquina. Este es el valor de "K".
	movwf	R_ContA				; Aporta Mx1 ciclos mquina.
R1ms_BucleInterno
	nop							; Aporta KxMx1 ciclos mquina.
	decfsz	R_ContA,F			; (K-1)xMx1 cm (cuando no salta) + Mx2 cm (al saltar).
	goto	R1ms_BucleInterno	; Aporta (K-1)xMx2 ciclos mquina.
	decfsz	R_ContB,F			; (M-1)x1 cm (cuando no salta) + 2 cm (al saltar).
	goto	R1ms_BucleExterno 	; Aporta (M-1)x2 ciclos mquina.
	return						; El salto del retorno aporta 2 ciclos mquina.

Retardo_1s						; La llamada "call" aporta 2 ciclos mquina.
	movlw	d'10'				; Aporta 1 ciclo mquina. Este es el valor de "N".
	goto	Retardo_1Decima		; Aporta 2 ciclos mquina.
Retardo_500ms					; La llamada "call" aporta 2 ciclos mquina.
	movlw	d'5'				; Aporta 1 ciclo mquina. Este es el valor de "N".
Retardo_1Decima
	movwf	R_ContC				; Aporta 1 ciclo mquina.
R1Decima_BucleExterno2
	movlw	d'100'				; Aporta Nx1 ciclos mquina. Este es el valor de "M".
	movwf	R_ContB				; Aporta Nx1 ciclos mquina.
R1Decima_BucleExterno
	movlw	d'249'				; Aporta MxNx1 ciclos mquina. Este es el valor de "K".
	movwf	R_ContA				; Aporta MxNx1 ciclos mquina.
R1Decima_BucleInterno          
	nop							; Aporta KxMxNx1 ciclos mquina.
	decfsz	R_ContA,F			; (K-1)xMxNx1 cm (si no salta) + MxNx2 cm (al saltar).
	goto	R1Decima_BucleInterno	; Aporta (K-1)xMxNx2 ciclos mquina.
	decfsz	R_ContB,F			; (M-1)xNx1 cm (cuando no salta) + Nx2 cm (al saltar).
	goto	R1Decima_BucleExterno	; Aporta (M-1)xNx2 ciclos mquina.
	decfsz	R_ContC,F			; (N-1)x1 cm (cuando no salta) + 2 cm (al saltar).
	goto	R1Decima_BucleExterno2	; Aporta (N-1)x2 ciclos mquina.
	return


end;finalizacion del programa
